package com.cf.imes.module.system.enums.pay;

import com.baomidou.mybatisplus.annotation.EnumValue;
import com.fasterxml.jackson.annotation.JsonCreator;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Objects;

/**
 * 支付订单状态
 *
 * @author Gqr
 * @since 2025/4/15 11:48
 */
@Getter
@AllArgsConstructor
public enum PayOrderStatusEnum {
    /**
     * 等待支付
     */
    WAITING(0),

    /**
     * 支付成功
     */
    SUCCESS(10),

    /**
     * 支付失败
     */
    FAIL(20);

    @EnumValue
    private final Integer status;

    @JsonCreator
    public static PayOrderStatusEnum fromType(Integer type) {
        for (PayOrderStatusEnum value : values()) {
            if (value.getStatus().equals(type)) {
                return value;
            }
        }
        return null;
    }

    /**
     * 判断是否支付成功
     *
     * @param status 状态
     * @return 是否支付成功
     */
    public static boolean isSuccess(Integer status) {
        return Objects.equals(status, SUCCESS.getStatus());
    }

    /**
     * 判断是否支付关闭
     *
     * @param status 状态
     * @return 是否支付关闭
     */
    public static boolean isClosed(Integer status) {
        return Objects.equals(status, FAIL.getStatus());
    }
}
